unit Steam_Servers;

interface

uses
  Windows, WinSock2, KOL;

type


  pMasterServerClient = ^TMasterServerClient;
  TMasterServerClient = object (TObj) 
    private
      sock: TSocket;
      fIPAddr: TIP;
    public
      function Initializations(Server: Ansistring): boolean;

      procedure GetServerList(commands: array of Ansistring);
    end;

const
  SSQ_UDP_GS = 0;
  SSQ_UDP_LOG = 1;
  SSQ_UDP_MS = 2;
  SSQ_TCP_RCON = 3;

function NewSteamServers(): pSteamServers;

implementation

function Arr2Str(arr: array of byte): string;
var
  s: string;
begin
  s:=Int2Str(arr[0])+'.'+Int2Str(arr[1])+'.'+Int2Str(arr[2])+'.'+Int2Str(arr[3]);
  result:=pChar(s);
end;

function memcpy(dst: Pointer; const src: Pointer; len: integer): Pointer;
begin
  Move(src^, dst^, len);
  Result := dst;
end;

function memset(buf: Pointer; c: Integer; len: integer): Pointer;
begin
  FillChar(buf^, len, c);
  Result := buf;
end;

function NewSteamServers(): pSteamServers;
var 
  WSA: TWSAData;
begin  
  if WSAStartup(MAKEWORD(2,2), WSA)<>0 then
    Exit;
 { if not Winsock2Loaded then
    Exit;    }

  New(result, Create);
end;


end.
