function TSteamNetWork.LogIn(UserName, UserPassword: pAnsiChar): boolean;
var
  bAccepted: boolean;
  Sock: TSocket;
  recvIP: TIP;
  szData: array[0..25] of byte;
  Host: PHostEnt;
  name, namehash: pAnsiChar;
  namelen, u: ulong;

  external_ip_bin: array[0..4] of byte;
begin
  result:=false;
  bAccepted:=false;

  Sock:=Socket(fConfigServer.AddrType, fConfigServer.Length, IPPROTO_IP);
  if not Connect(Sock, pAnsiChar(Arr2Str(fConfigServer.IP.IP)), fConfigServer.IP.Port) then
    Exit;
  if send(Sock, GD_CLIENTVER, 4, 0)=SOCKET_ERROR then
    Exit;
  if recv(Sock, bAccepted, 1, 0)=SOCKET_ERROR then
    Exit;
  if not bAccepted then
    Exit;
  FillChar(szData, 25, 0);
  szData[3]:=$05;
  szData[5]:=$d4;
  szData[6]:=$8f;
  szData[7]:=$d3;
  szData[8]:=$c3;
  if send(Sock, szData[0], 9, 0)=SOCKET_ERROR then
    Exit;   
  FillChar(szData, 25, 0);
  if recv(Sock, szData[0], 4, 0)=SOCKET_ERROR then
    Exit;
  FillChar(szData, 25, 0);
  if recv(Sock, szData[0], 2, 0)=SOCKET_ERROR then
    Exit;
  if recv(Sock, recvIP.IP, 4, 0)=SOCKET_ERROR then
    Exit;
  if recv(Sock, recvIP.Port, 2, 0)=SOCKET_ERROR then
    Exit;       
  CloseSocket(Sock);

  Sock:=Socket(fConfigServer.AddrType, fConfigServer.Length, IPPROTO_IP);
  if not Connect(Sock, pAnsiChar(Arr2Str(recvIP.IP)), recvIP.Port) then
    Exit;
  external_ip_bin[4]:=$04;

  if send(Sock, external_ip_bin[0], 5, 0)=SOCKET_ERROR then
    Exit;
  name:='';
  GetMem(name, $100);
  if GetHostName(name, $100)<>0 then
    Exit;
  Host:=GetHostByName(name);
  Move(Host^.h_addr_list^[0], fMyHost.IP.IP[0], 4);
  //fMyHost.IP.Port:=Port;
  fMyHost.AddrType:=Host.h_addrtype;
  fMyHost.Length:=1;

  Move(fMyHost.IP.IP[0], szData[0], 4);
  if Send(Sock, fMyHost.IP.IP[0], 4, 0)=SOCKET_ERROR then
    Exit;
  namehash:=bytes_from_int(userhash(pAnsiChar(UserName)));
  if Send(Sock, namehash, 4, 0)=SOCKET_ERROR then
    Exit;

  if recv(Sock, bAccepted, 1, 0)=SOCKET_ERROR then
    Exit;
  if bAccepted then
    Exit; 
  if recv(Sock, fMyHost.IP.IP[0], 4, 0)=SOCKET_ERROR then
    Exit;
  FillChar(szData, 25, 0);
  szData[3]:=$15;
  
  u:=2*Length(UserName) + 5;
  if send(Sock, u, 4, 0)=SOCKET_ERROR then
    Exit;
  FillChar(szData, 25, 0);
  szData[0]:=$02;
  if send(Sock, szData[0], 1, 0)=SOCKET_ERROR then
    Exit;
  namelen:=Length(UserName);
  if send(Sock, namelen, 2, 0)=SOCKET_ERROR then
    Exit;
    
  if send(Sock, UserName, namelen, 0)=SOCKET_ERROR then
    Exit;   
  if send(Sock, namelen, 2, 0)=SOCKET_ERROR then
    Exit; 
  if send(Sock, UserName, namelen, 0)=SOCKET_ERROR then
    Exit;
    
  FillChar(szData, 25, 0);
  if recv(Sock, szData[0], 8, 0)=SOCKET_ERROR then
    Exit;

    {  memset(@Buffer2[0], 0, 8 + Length(Password));
      memcpy(@Buffer2[0], @Buffer[0], 4);
      memcpy(@Buffer2[4], @Password[1], Length(Password));
      memcpy(@Buffer2[4 + Length(Password)], @Buffer[4], 4);

      SHA1:=NewSHA1;
      SHA1.addBytes(pChar(@Buffer2[0]), Length(Password) + 8);
      GetMem(key, 15);
      FillChar(key, 0, 15);
      memcpy(key, sha1.getDigest, 16);
      SHA1.Free;

      memset(@Buffer2[0], 0, 8);
      memcpy(@Buffer2[0], my_strrev(@external_ip_bin, 4), 4);
      memcpy(@Buffer2[4], @local_ip_bin[0], 4); 

      SHA1:=NewSHA1;
      SHA1.addBytes(pChar(@Buffer2[0]), 8);
      memcpy(@xorkey[0], sha1.getDigest, 8);
      SHA1.Free;

      memset(@steamtimestamp, 0, 8);
      timestamp:=(Gettime + 62135596800) * 1000000;
      memcpy(@steamtimestamp, @timestamp, 8);

      memset(@cleartext, 0, 16);
      for i:=0 to 7 do
        cleartext[i]:=xorkey[i] xor steamtimestamp[i];

      memcpy(@cleartext[8], @local_ip_bin, 4);
      tmp:=#$04#$04#$04#$04;
      memcpy(@cleartext[12], tmp, 4);

      tmp:=#$51#$83#$AC#$D5#$10#$52#$A6#$CF#$72#$98#$F7#$0B#$46#$87#$BC#$B9;
      memcpy(@iv, tmp, 16);

      memset(@cleartext, 0, 16);
      aes_SetIV(@iv[0]);
      aes_Encrypt(@cleartext[0], @key[0], @ciphertext[0]);

      tmp:=#$00#$00#$00#$24;
      if send(iSocket, tmp^, 4, 0)=SOCKET_ERROR then
        Exit;
      if send(iSocket, iv[0], 16, 0)=SOCKET_ERROR then
        Exit;
      tmp:=#$00#$0c#$00#$10;
      if send(iSocket, tmp^, 4, 0)=SOCKET_ERROR then
        Exit;
      if send(iSocket, ciphertext[0], 16, 0)=SOCKET_ERROR then
        Exit;
      memset(@Buffer[0], 0, 1);
      recvlen:=recv(iSocket, Buffer[0], 1, 0);
      memset(@Buffer[0], 0, 16);
      recvlen:=recv(iSocket, Buffer[0], 16, 0);
      memset(@Buffer[0], 0, 4);
      recvlen:=recv(iSocket, Buffer[0], 4, 0);
      loginpacketlen:=int_from_bytes(pChar(@Buffer[0]));
      memset(@Buffer[0], 0, loginpacketlen);
      recvlen:=recv(iSocket, Buffer[0], 16, loginpacketlen);
      if RecvLen<>loginpacketlen then
        Exit;
      ticketlen:=((Buffer[86] shl 8) + Buffer[87]);
      GetMem(iTicket, ticketlen);
      memset(iTicket, 0, ticketlen);
      memcpy(iTicket, @Buffer[88], ticketlen);


            }
  {FillChar(szData, 25, 0);
  szData[3]:=$24;
  if send(Sock, szData[0], 4, 0)=SOCKET_ERROR then
    Exit;
  //             2241 8160 4
  {SHA1:=NewSHA1;
     
  if send(Sock, SHA1., 4, 0)=SOCKET_ERROR then
    Exit; }

  result:=true;
end;
